diff --git a/QuantLib/ql/pricingengines/vanilla/Makefile.am b/QuantLib/ql/pricingengines/vanilla/Makefile.am
index bc61760..b3a5355 100644
--- a/QuantLib/ql/pricingengines/vanilla/Makefile.am
+++ b/QuantLib/ql/pricingengines/vanilla/Makefile.am
@@ -44,7 +44,8 @@ this_include_HEADERS = \
     mceuropeanhestonengine.hpp \
     mceuropeangjrgarchengine.hpp \
     mchestonhullwhiteengine.hpp \
-    mcvanillaengine.hpp
+    mcvanillaengine.hpp \
+    hestonexpansionengine.hpp
 
 libVanillaEngines_la_SOURCES = \
     analyticbsmhullwhiteengine.cpp \
@@ -71,7 +72,8 @@ libVanillaEngines_la_SOURCES = \
     fdvanillaengine.cpp \
     mcamericanengine.cpp \
     mcdigitalengine.cpp \
-    mchestonhullwhiteengine.cpp
+    mchestonhullwhiteengine.cpp \
+    hestonexpansionengine.cpp
 
 noinst_LTLIBRARIES = libVanillaEngines.la
 
diff --git a/QuantLib/ql/pricingengines/vanilla/all.hpp b/QuantLib/ql/pricingengines/vanilla/all.hpp
index 0d65f6b..3b42d3d 100644
--- a/QuantLib/ql/pricingengines/vanilla/all.hpp
+++ b/QuantLib/ql/pricingengines/vanilla/all.hpp
@@ -42,4 +42,5 @@
 #include <ql/pricingengines/vanilla/mceuropeangjrgarchengine.hpp>
 #include <ql/pricingengines/vanilla/mchestonhullwhiteengine.hpp>
 #include <ql/pricingengines/vanilla/mcvanillaengine.hpp>
+#include <ql/pricingengines/vanilla/hestonexpansionengine.hpp>
 
diff --git a/QuantLib/ql/pricingengines/vanilla/hestonexpansionengine.hpp b/QuantLib/ql/pricingengines/vanilla/hestonexpansionengine.hpp
new file mode 100644
index 0000000..b3d74ff
--- /dev/null
+++ b/QuantLib/ql/pricingengines/vanilla/hestonexpansionengine.hpp
@@ -0,0 +1,127 @@
+/* -*- mode: c++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+
+/*
+ Copyright (C) 2014 Fabien Le Floc'h
+
+ This file is part of QuantLib, a free-software/open-source library
+ for financial quantitative analysts and developers - http://quantlib.org/
+
+ QuantLib is free software: you can redistribute it and/or modify it
+ under the terms of the QuantLib license.  You should have received a
+ copy of the license along with this program; if not, please email
+ <quantlib-dev@lists.sf.net>. The license is also available online at
+ <http://quantlib.org/license.shtml>.
+
+ This program is distributed in the hope that it will be useful, but WITHOUT
+ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ FOR A PARTICULAR PURPOSE.  See the license for more details.
+*/
+
+/*! \file analytichestonengine.hpp
+    \brief analytic Heston expansion engine 
+*/
+
+#ifndef quantlib_heston_expansion_engine_hpp
+#define quantlib_heston_expansion_engine_hpp
+
+#include <ql/pricingengines/genericmodelengine.hpp>
+#include <ql/models/equity/hestonmodel.hpp>
+#include <ql/instruments/vanillaoption.hpp>
+
+#include <boost/function.hpp>
+
+namespace QuantLib {
+
+    //! analytic Heston-model engine based on analytic expansions
+
+    /*! References:
+
+        M Forde, A Jacquier, R Lee, The small-time smile and term structure of implied volatility under the Heston model
+        SIAM Journal on Financial Mathematics, 2012 - SIAM
+
+        M Lorig, S Pagliarani, A Pascucci, Explicit implied vols for multifactor local-stochastic vol models
+        arXiv preprint arXiv:1306.5447v3, 2014 - arxiv.org
+
+        \ingroup vanillaengines
+    */
+    class HestonExpansionEngine
+        : public GenericModelEngine<HestonModel,
+                                    VanillaOption::arguments,
+                                    VanillaOption::results> {
+      public:
+        enum HestonExpansionFormula { LPP2, LPP3, Forde };
+
+        HestonExpansionEngine(const boost::shared_ptr<HestonModel>& model,
+                             HestonExpansionFormula formula);
+
+
+        void calculate() const;
+        Size numberOfEvaluations() const;
+
+      private:
+        mutable Size evaluations_;
+        const HestonExpansionFormula formula_;
+    };
+
+    /*! Interface to represent some Heston Expansion formula.
+        During calibration, it would typically be initialized once per 
+        implied volatility surface slice, then calls for each surface strike to
+        impliedVolatility(strike, forward) would be performed. 
+    */
+    class HestonExpansion {
+      public:
+        virtual ~HestonExpansion() {}
+        virtual Real impliedVolatility(const Real strike, const Real forward) const = 0;
+    };
+    /*! Lorig Pagliarani Pascucci Expansion of order-2 for the Heston model.
+        During calibration, it can be initialized once per expiry, and called
+        many times with different strikes.
+        The formula is also available in the Mathematica notebook from the authors at
+        http://explicitsolutions.wordpress.com/
+    */
+    class LPP2Expansion : public HestonExpansion {
+      public:
+        LPP2Expansion(const Real kappa, const Real theta, const Real sigma, const Real v0, const Real rho, const Real term);
+        virtual Real impliedVolatility(const Real strike, const Real forward) const;
+      private:
+        Real coeffs[3];
+        Real ekt, e2kt, e3kt, e4kt;
+        Real z0(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+        Real z1(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+        Real z2(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+    };
+
+    /*! Lorig Pagliarani Pascucci Expansion of order-3 for the Heston model.
+        During calibration, it can be initialized once per expiry, and called
+        many times with different strikes.
+        The formula is also available in the Mathematca notebook from the authors at
+        http://explicitsolutions.wordpress.com/
+    */
+    class LPP3Expansion : public HestonExpansion{
+      public:
+        LPP3Expansion(const Real kappa, const Real theta, const Real sigma, const Real v0, const Real rho, const Real term);
+        virtual Real impliedVolatility(const Real strike, const Real forward) const;
+      private:
+        Real coeffs[4];
+        Real ekt, e2kt, e3kt, e4kt;
+        Real z0(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+        Real z1(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+        Real z2(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+        Real z3(Real t, Real kappa, Real theta, Real delta, Real y, Real rho) const;
+    };
+
+    /*!Small-time expansion from 
+         "The small-time smile and term structure of implied volatility under the Heston model"
+         M Forde, A Jacquier, R Lee - SIAM Journal on Financial Mathematics, 2012 - SIAM
+    */
+    class FordeExpansion : public HestonExpansion {
+      public:
+        FordeExpansion(const Real kappa, const Real theta, const Real sigma, const Real v0, const Real rho, const Real term);
+        virtual Real impliedVolatility(const Real strike, const Real forward) const;
+      private:
+        Real coeffs[5];
+    };    
+    
+}
+
+#endif
diff --git a/QuantLib/test-suite/hestonmodel.cpp b/QuantLib/test-suite/hestonmodel.cpp
index 0ed8e85..7e47fb0 100644
--- a/QuantLib/test-suite/hestonmodel.cpp
+++ b/QuantLib/test-suite/hestonmodel.cpp
@@ -28,6 +28,7 @@
 #include <ql/models/equity/piecewisetimedependenthestonmodel.hpp>
 #include <ql/pricingengines/vanilla/analyticdividendeuropeanengine.hpp>
 #include <ql/pricingengines/vanilla/analytichestonengine.hpp>
+#include <ql/pricingengines/vanilla/hestonexpansionengine.hpp>
 #include <ql/pricingengines/vanilla/fdamericanengine.hpp>
 #include <ql/pricingengines/vanilla/fddividendeuropeanengine.hpp>
 #include <ql/pricingengines/vanilla/fdeuropeanengine.hpp>
@@ -47,10 +48,10 @@
 #include <ql/termstructures/yield/zerocurve.hpp>
 #include <ql/termstructures/yield/flatforward.hpp>
 #include <ql/math/optimization/levenbergmarquardt.hpp>
+#include <ql/math/optimization/differentialevolution.hpp>
 #include <ql/time/period.hpp>
 #include <ql/quotes/simplequote.hpp>
 
-
 using namespace QuantLib;
 using namespace boost::unit_test_framework;
 
@@ -1330,6 +1331,152 @@ void HestonModelTest::testAnalyticPDFHestonEngine() {
     }
 }
 
+void HestonModelTest::testExpansionOnAlanLewisReference() {
+    BOOST_TEST_MESSAGE("Testing Expansion on Alan Lewis reference prices...");
+
+    SavedSettings backup;
+
+    const Date settlementDate(5, July, 2002);
+    Settings::instance().evaluationDate() = settlementDate;
+
+    const Date maturityDate(5, July, 2003);
+    const boost::shared_ptr<Exercise> exercise(
+        new EuropeanExercise(maturityDate));
+
+    const DayCounter dayCounter = Actual365Fixed();
+    const Handle<YieldTermStructure> riskFreeTS(flatRate(0.01, dayCounter));
+    const Handle<YieldTermStructure> dividendTS(flatRate(0.02, dayCounter));
+
+    const Handle<Quote> s0(boost::shared_ptr<Quote>(new SimpleQuote(100.0)));
+
+    const Real v0    =  0.04;
+    const Real rho   = -0.5;
+    const Real sigma =  1.0;
+    const Real kappa =  4.0;
+    const Real theta =  0.25;
+
+    const boost::shared_ptr<HestonProcess> process(new HestonProcess(
+        riskFreeTS, dividendTS, s0, v0, kappa, theta, sigma, rho));
+    const boost::shared_ptr<HestonModel> model(new HestonModel(process));
+
+    const boost::shared_ptr<PricingEngine> lpp2Engine(
+        new HestonExpansionEngine(model, HestonExpansionEngine::LPP2));
+    //don't test Forde as it does not behave well on this example
+    const boost::shared_ptr<PricingEngine> lpp3Engine(
+        new HestonExpansionEngine(model, HestonExpansionEngine::LPP3));
+
+    const Real strikes[] = { 80, 90, 100, 110, 120 };
+    const Option::Type types[] = { Option::Put, Option::Call };
+    const boost::shared_ptr<PricingEngine> engines[]
+        = { lpp2Engine, lpp3Engine };
+
+    const Real expectedResults[][2] = {
+        { 7.958878113256768285213263077598987193482161301733,
+          26.774758743998854221382195325726949201687074848341 },
+        { 12.017966707346304987709573290236471654992071308187,
+          20.933349000596710388139445766564068085476194042256 },
+        { 17.055270961270109413522653999411000974895436309183,
+          16.070154917028834278213466703938231827658768230714 },
+        { 23.017825898442800538908781834822560777763225722188,
+          12.132211516709844867860534767549426052805766831181 },
+        { 29.811026202682471843340682293165857439167301370697,
+          9.024913483457835636553375454092357136489051667150  }
+    };
+
+    const Real tol[2] = {1.003e-2, 3.645e-3}; 
+
+    for (Size i=0; i < LENGTH(strikes); ++i) {
+        const Real strike = strikes[i];
+
+        for (Size j=0; j < LENGTH(types); ++j) {
+            const Option::Type type = types[j];
+
+            for (Size k=0; k < LENGTH(engines); ++k) {
+                const boost::shared_ptr<PricingEngine> engine = engines[k];
+
+                const boost::shared_ptr<StrikedTypePayoff> payoff(
+                    new PlainVanillaPayoff(type, strike));
+
+                VanillaOption option(payoff, exercise);
+                option.setPricingEngine(engine);
+
+                const Real expected = expectedResults[i][j];
+                const Real calculated = option.NPV();
+                const Real relError = std::fabs(calculated-expected)/expected;
+
+                if (relError > tol[k]) {
+                    BOOST_ERROR(
+                           "failed to reproduce Alan Lewis Reference prices "
+                        << "\n    strike     : " << strike
+                        << "\n    option type: " << type
+                        << "\n    engine type: " << k
+                        << "\n    rel. error : " << relError);
+                }
+            }
+        }
+    }
+}
+
+void HestonModelTest::testExpansionOnFordeReference() {
+    BOOST_TEST_MESSAGE("Testing Expansion on Alan Lewis reference prices...");
+
+    SavedSettings backup;
+
+    const Real forward = 100.0;
+    const Real v0      =  0.04;
+    const Real rho     = -0.4;
+    const Real sigma   =  0.2;
+    const Real kappa   =  1.15;
+    const Real theta   =  0.04;
+
+    const Real terms[] = {0.1, 1.0, 5.0, 10.0};
+
+    const Real strikes[] = { 60, 80, 90, 100, 110, 120, 140 };
+
+    const Real referenceVols[][7] = {
+       {0.27284673574924445, 0.22360758200372477, 0.21023988547031242, 0.1990674789471587, 0.19118230678920461, 0.18721342919371017, 0.1899869903378507},
+       {0.25200775151345, 0.2127275920953156, 0.20286528150874591, 0.19479398358151515, 0.18872591728967686, 0.18470857955411824, 0.18204457060905446},
+       {0.21637821506229973, 0.20077227130455172, 0.19721753043236154, 0.1942233023784151, 0.191693211401571, 0.18955229722896752, 0.18491727548069495},
+       {0.20672925973965342, 0.198583062164427, 0.19668274423922746, 0.1950420231354201, 0.193610364344706, 0.1923502827886502, 0.18934360917857015}
+    };
+
+    const Real tol[][4] = {
+        {0.06, 0.03, 0.03, 0.02},
+        {0.15, 0.08, 0.04, 0.02},
+        {0.06, 0.08, 1.0, 1.0} //forde breaks down for long maturities
+    }; 
+    const Real tolAtm[][4] = {
+        {4e-6, 7e-4, 2e-3, 9e-4},
+        {7e-6, 4e-4, 9e-4, 4e-4},
+        {4e-4, 3e-2, 0.28, 1.0}
+    };
+    for (Size j=0; j < LENGTH(terms); ++j) {
+        const Real term = terms[j];
+        const boost::shared_ptr<HestonExpansion> lpp2(new LPP2Expansion(kappa, theta, sigma, v0, rho, term));
+        const boost::shared_ptr<HestonExpansion> lpp3(new LPP3Expansion(kappa, theta, sigma, v0, rho, term));
+        const boost::shared_ptr<HestonExpansion> forde(new FordeExpansion(kappa, theta, sigma, v0, rho, term));
+        const boost::shared_ptr<HestonExpansion> expansions[] = { lpp2, lpp3, forde };
+        for (Size i=0; i < LENGTH(strikes); ++i) {
+            const Real strike = strikes[i];
+            for (Size k=0; k < LENGTH(expansions); ++k) {
+                const boost::shared_ptr<HestonExpansion> expansion = expansions[k];
+
+                const Real expected = referenceVols[j][i];
+                const Real calculated = expansion->impliedVolatility(strike, forward);
+                const Real relError = std::fabs(calculated-expected)/expected;
+                const Real refTol = strike == forward ? tolAtm[k][j] : tol[k][j];
+                if (relError > refTol) {
+                    BOOST_ERROR(
+                           "failed to reproduce Forde reference vols "
+                        << "\n    strike        : " << strike
+                        << "\n    expansion type: " << k
+                        << "\n    rel. error    : " << relError);
+                }
+            }
+        }
+    }
+}
+
 test_suite* HestonModelTest::suite() {
     test_suite* suite = BOOST_TEST_SUITE("Heston model tests");
 
@@ -1352,7 +1499,8 @@ test_suite* HestonModelTest::suite() {
                     &HestonModelTest::testDAXCalibrationOfTimeDependentModel));
     suite->add(QUANTLIB_TEST_CASE(
                     &HestonModelTest::testAlanLewisReferencePrices));
-
+    suite->add(QUANTLIB_TEST_CASE(&HestonModelTest::testExpansionOnAlanLewisReference));
+    suite->add(QUANTLIB_TEST_CASE(&HestonModelTest::testExpansionOnFordeReference));
     return suite;
 }
 
diff --git a/QuantLib/test-suite/hestonmodel.hpp b/QuantLib/test-suite/hestonmodel.hpp
index c353013..9629fea 100644
--- a/QuantLib/test-suite/hestonmodel.hpp
+++ b/QuantLib/test-suite/hestonmodel.hpp
@@ -41,6 +41,8 @@ class HestonModelTest {
     static void testDAXCalibrationOfTimeDependentModel();
     static void testAlanLewisReferencePrices();
     static void testAnalyticPDFHestonEngine();
+    static void testExpansionOnAlanLewisReference();
+    static void testExpansionOnFordeReference();
     static boost::unit_test_framework::test_suite* suite();
     static boost::unit_test_framework::test_suite* experimental();
 };
